package com.landray.kmss.sys.attachment.borrow.transfer;

import org.hibernate.query.NativeQuery;
import org.hibernate.Session;
import com.landray.kmss.sys.admin.transfer.constant.ISysAdminTransferConstant;
import com.landray.kmss.util.SpringBeanUtil;
import com.landray.kmss.sys.attachment.borrow.service.ISysAttBorrowService;
import com.landray.kmss.sys.admin.transfer.service.spring.SysAdminTransferResult;
import com.landray.kmss.sys.admin.transfer.service.spring.SysAdminTransferContext;
import org.slf4j.LoggerFactory;
import org.slf4j.Logger;
import com.landray.kmss.sys.admin.transfer.service.ISysAdminTransferTask;

public class SysAttBorrowTask implements ISysAdminTransferTask
{
    private final Logger logger;
    private final String sql = "update sys_att_main set fd_borrow_count = 0 where fd_borrow_count is null";
    
    public SysAttBorrowTask() {
        this.logger = LoggerFactory.getLogger(this.getClass());
    }
    
    public SysAdminTransferResult run(final SysAdminTransferContext context) {
        final ISysAttBorrowService service = (ISysAttBorrowService)SpringBeanUtil.getBean("sysAttBorrowService");
        Session session = null;
        try {
            session = service.getBaseDao().getHibernateSession();
            final NativeQuery nativeQuery = session.createNativeQuery("update sys_att_main set fd_borrow_count = 0 where fd_borrow_count is null");
            nativeQuery.addSynchronizedQuerySpace("sys_att_main").executeUpdate();
            return SysAdminTransferResult.OK;
        }
        catch (final Exception e) {
            this.logger.error("附件借阅数迁移报错：", e);
            return new SysAdminTransferResult(ISysAdminTransferConstant.TASK_STATUS_NOT_RUNED, e.getMessage());
        }
    }
}
